#ifndef LIBREGEXIS024_SRC_LIBREGEXIS024FA_FILTER_H
#define LIBREGEXIS024_SRC_LIBREGEXIS024FA_FILTER_H

#include <stdlib.h>
#include <stdint.h>
#include <libregexis024fa/codeset.h>
#include <libregexis024fa/graph_to_bytecode/natural_compiler_utils.h>

namespace regexis024 {
    struct FilterSegment {
        ssize_t color;
        uint32_t L;
        uint32_t R;
    };

    /* Return whether user of function must place [0]'th option after the filter
    * The filter can end up being written in such a way that the end will never be reached */
    bool write_filter(std::vector<uint8_t>& result, explicit_bookmarks& bookmark_manager,
        const std::vector<codeset_t>& crossroad_codesets, const std::vector<bookmark_id_t>& crossroad_marks);
}

#endif
