#ifndef LIBREGEXIS024_TRACKING_FA_NODES_H
#define LIBREGEXIS024_TRACKING_FA_NODES_H

#include <libregexis024vm/vm_opcodes.h>
#include <libregexis024fa/finite_automaton.h>
#include <string>

namespace regexis024 {
    bool isImmMovOpcode(opcode_t inst);
    bool isCurPosMovOpcode(opcode_t inst);
    bool isColarrOpcode(opcode_t inst);
    bool isSelarrOpcode(opcode_t inst);

    bool isTrackingFaNode(const FA_Node* n);

    struct TrackingOperationInFa {
        opcode_t opcode;
        tai_t key;
        /* Not needed for halfinvariant operations */
        uint64_t immValue;

        std::string toString() const;
    };

    FA_NodePathPart* convert_to_node(const TrackingOperationInFa& op, FA_Container& fa);
}

#endif
