/* DO NOT INCLUDE THIS FILE OUTSIDE libregexis024sol implementation */
#ifndef LIBREGEXIS024_SRC_LIBREGEXIS024SOL_SPECIAL_TERMINALS_H
#define LIBREGEXIS024_SRC_LIBREGEXIS024SOL_SPECIAL_TERMINALS_H

#include <libregexis024sol/expr_compiler.h>
#include <libregexis024sol/common_codesets.h>

namespace regexis024 {
    /* This option of backslash usage should be checked last.
     * Function can generate error. Always check the error first */
    void
    backslash_expression_parsing_try_regular(REGEX_IS024_MeaningContext& ctx, const CommonCodesets& cc,
        bool& ret_is_multicode, codeset_t& ret_set);

    struct CommandEntity;
    struct Command;
    struct CommandArgument;

    struct CommandEntity{
        std::string name;
        std::vector<CommandArgument> arguments;
    };

    struct CommandArgument: CommandEntity{
        bool is_empty = true;
    };

    struct Command: CommandEntity{
        bool tilda = false;
    };

    /* Zlaya sobaka. Kidaet oshibki v context */
    Command command_expr_parse(REGEX_IS024_MeaningContext& ctx);
    bool is_command_for_charset(const Command& cmd);
    void interpret_command_as_charset_giving(const CommonCodesets& cc, const Command& cmd, codeset_t& ret);
}

#endif //LIBREGEXIS024_SRC_LIBREGEXIS024SOL_SPECIAL_TERMINALS_H
