#ifndef LIBREGEXIS024_SRC_LIBREGEXIS024TOOLS_STRINGMATCHING_H
#define LIBREGEXIS024_SRC_LIBREGEXIS024TOOLS_STRINGMATCHING_H

#include <libregexis024fa/tracking_variables.h>
#include <map>
#include <string>
#include <libregexis024vm/libregexis024vm_interface.h>

namespace regexis024 {
    struct TrackingVariableInfo {
        bool stored_in_ca = true;
        bool stored_in_sa = false;

        tracking_var_type_t type;
        /* These fields will be -1 if unused */
        int colarr_first = -1;
        int colarr_second = -1;

        int selarr_first = -1;
        int selarr_second = -1;
    };

    typedef std::map<std::string, TrackingVariableInfo> track_var_list;

    struct MatchInfo {
        bool have_match = false;
        std::vector<CAEvent> ca_history;
        std::vector<uint64_t> sa;

        bool operator==(const MatchInfo& other) const ;
        bool operator!=(const MatchInfo& other) const ;

        MatchInfo() = default;

        MatchInfo(const std::vector<CAEvent> &ca_history, const std::vector<uint64_t> &sa);
    };

    int matchStrToRegexp(const std::string& input, const std::string& pattern,
        MatchInfo& retMatchInfo, track_var_list& retTrackVarList, std::string& retStatus);
}

#endif
