#include <libregexis024vm/libregexis024vm.h>
#include <libregexis024vm/vm_opcodes.h>

namespace regexis024 {
    bool VMContext::check_inboundness(int region){
        return vmprog_check_inboundness(program_size, active_thread.IP, region);
    }

    uint8_t VMContext::extract_b() {
        return vmprog_extract_b(&active_thread.IP, prg);
    }

    uint16_t VMContext::extract_w() {
        return vmprog_extract_w(&active_thread.IP, prg);
    }

    uint32_t VMContext::extract_dw() {
        return vmprog_extract_dw(&active_thread.IP, prg);
    }

    uint64_t VMContext::extract_qw() {
        return vmprog_extract_qw(&active_thread.IP, prg);
    }

    uint8_t VMContext::extract_instruction() {
        return extract_b();
    }

    sslot_id_t VMContext::extract_sslot_id() {
        return extract_dw();
    }

    near_ptr_t VMContext::extract_near_pointer() {
        return extract_qw();
    }

    tai_t VMContext::extract_track_array_index() {
        return extract_w();
    }
}
